
;CodeVisionAVR C Compiler V1.25.8 Professional
;(C) Copyright 1998-2007 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com

;Chip type              : ATmega88
;Program type           : Application
;Clock frequency        : 14,745600 MHz
;Memory model           : Small
;Optimize for           : Size
;(s)printf features     : int, width
;(s)scanf features      : int, width
;External SRAM size     : 0
;Data Stack size        : 256 byte(s)
;Heap size              : 0 byte(s)
;Promote char to int    : No
;char is unsigned       : Yes
;8 bit enums            : Yes
;Word align FLASH struct: No
;Enhanced core instructions    : On
;Smart register allocation : On
;Automatic register allocation : On

	#pragma AVRPART ADMIN PART_NAME ATmega88
	#pragma AVRPART MEMORY PROG_FLASH 8192
	#pragma AVRPART MEMORY EEPROM 512
	#pragma AVRPART MEMORY INT_SRAM SIZE 1024
	#pragma AVRPART MEMORY INT_SRAM START_ADDR 0x100

	.EQU EERE=0x0
	.EQU EEWE=0x1
	.EQU EEMWE=0x2
	.EQU UDRE=0x5
	.EQU RXC=0x7
	.EQU EECR=0x1F
	.EQU EEDR=0x20
	.EQU EEARL=0x21
	.EQU EEARH=0x22
	.EQU SPSR=0x2D
	.EQU SPDR=0x2E
	.EQU SMCR=0x33
	.EQU MCUSR=0x34
	.EQU MCUCR=0x35
	.EQU WDTCSR=0x60
	.EQU UCSR0A=0xC0
	.EQU UDR0=0xC6
	.EQU SPL=0x3D
	.EQU SPH=0x3E
	.EQU SREG=0x3F
	.EQU GPIOR0=0x1E

	.DEF R0X0=R0
	.DEF R0X1=R1
	.DEF R0X2=R2
	.DEF R0X3=R3
	.DEF R0X4=R4
	.DEF R0X5=R5
	.DEF R0X6=R6
	.DEF R0X7=R7
	.DEF R0X8=R8
	.DEF R0X9=R9
	.DEF R0XA=R10
	.DEF R0XB=R11
	.DEF R0XC=R12
	.DEF R0XD=R13
	.DEF R0XE=R14
	.DEF R0XF=R15
	.DEF R0X10=R16
	.DEF R0X11=R17
	.DEF R0X12=R18
	.DEF R0X13=R19
	.DEF R0X14=R20
	.DEF R0X15=R21
	.DEF R0X16=R22
	.DEF R0X17=R23
	.DEF R0X18=R24
	.DEF R0X19=R25
	.DEF R0X1A=R26
	.DEF R0X1B=R27
	.DEF R0X1C=R28
	.DEF R0X1D=R29
	.DEF R0X1E=R30
	.DEF R0X1F=R31

	.MACRO __CPD1N
	CPI  R30,LOW(@0)
	LDI  R26,HIGH(@0)
	CPC  R31,R26
	LDI  R26,BYTE3(@0)
	CPC  R22,R26
	LDI  R26,BYTE4(@0)
	CPC  R23,R26
	.ENDM

	.MACRO __CPD2N
	CPI  R26,LOW(@0)
	LDI  R30,HIGH(@0)
	CPC  R27,R30
	LDI  R30,BYTE3(@0)
	CPC  R24,R30
	LDI  R30,BYTE4(@0)
	CPC  R25,R30
	.ENDM

	.MACRO __CPWRR
	CP   R@0,R@2
	CPC  R@1,R@3
	.ENDM

	.MACRO __CPWRN
	CPI  R@0,LOW(@2)
	LDI  R30,HIGH(@2)
	CPC  R@1,R30
	.ENDM

	.MACRO __ADDB1MN
	SUBI R30,LOW(-@0-(@1))
	.ENDM
	.MACRO __ADDB2MN
	SUBI R26,LOW(-@0-(@1))
	.ENDM
	.MACRO __ADDW1MN
	SUBI R30,LOW(-@0-(@1))
	SBCI R31,HIGH(-@0-(@1))
	.ENDM
	.MACRO __ADDW2MN
	SUBI R26,LOW(-@0-(@1))
	SBCI R27,HIGH(-@0-(@1))
	.ENDM
	.MACRO __ADDW1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	.ENDM
	.MACRO __ADDD1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	SBCI R22,BYTE3(-2*@0-(@1))
	.ENDM
	.MACRO __ADDD1N
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	SBCI R22,BYTE3(-@0)
	SBCI R23,BYTE4(-@0)
	.ENDM

	.MACRO __ADDD2N
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	SBCI R24,BYTE3(-@0)
	SBCI R25,BYTE4(-@0)
	.ENDM

	.MACRO __SUBD1N
	SUBI R30,LOW(@0)
	SBCI R31,HIGH(@0)
	SBCI R22,BYTE3(@0)
	SBCI R23,BYTE4(@0)
	.ENDM

	.MACRO __SUBD2N
	SUBI R26,LOW(@0)
	SBCI R27,HIGH(@0)
	SBCI R24,BYTE3(@0)
	SBCI R25,BYTE4(@0)
	.ENDM

	.MACRO __ANDBMNN
	LDS  R30,@0+@1
	ANDI R30,LOW(@2)
	STS  @0+@1,R30
	.ENDM

	.MACRO __ANDWMNN
	LDS  R30,@0+@1
	ANDI R30,LOW(@2)
	STS  @0+@1,R30
	LDS  R30,@0+@1+1
	ANDI R30,HIGH(@2)
	STS  @0+@1+1,R30
	.ENDM

	.MACRO __ANDD1N
	ANDI R30,LOW(@0)
	ANDI R31,HIGH(@0)
	ANDI R22,BYTE3(@0)
	ANDI R23,BYTE4(@0)
	.ENDM

	.MACRO __ORBMNN
	LDS  R30,@0+@1
	ORI  R30,LOW(@2)
	STS  @0+@1,R30
	.ENDM

	.MACRO __ORWMNN
	LDS  R30,@0+@1
	ORI  R30,LOW(@2)
	STS  @0+@1,R30
	LDS  R30,@0+@1+1
	ORI  R30,HIGH(@2)
	STS  @0+@1+1,R30
	.ENDM

	.MACRO __ORD1N
	ORI  R30,LOW(@0)
	ORI  R31,HIGH(@0)
	ORI  R22,BYTE3(@0)
	ORI  R23,BYTE4(@0)
	.ENDM

	.MACRO __DELAY_USB
	LDI  R24,LOW(@0)
__DELAY_USB_LOOP:
	DEC  R24
	BRNE __DELAY_USB_LOOP
	.ENDM

	.MACRO __DELAY_USW
	LDI  R24,LOW(@0)
	LDI  R25,HIGH(@0)
__DELAY_USW_LOOP:
	SBIW R24,1
	BRNE __DELAY_USW_LOOP
	.ENDM

	.MACRO __CLRD1S
	LDI  R30,0
	STD  Y+@0,R30
	STD  Y+@0+1,R30
	STD  Y+@0+2,R30
	STD  Y+@0+3,R30
	.ENDM

	.MACRO __GETD1S
	LDD  R30,Y+@0
	LDD  R31,Y+@0+1
	LDD  R22,Y+@0+2
	LDD  R23,Y+@0+3
	.ENDM

	.MACRO __PUTD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R31
	STD  Y+@0+2,R22
	STD  Y+@0+3,R23
	.ENDM

	.MACRO __PUTD2S
	STD  Y+@0,R26
	STD  Y+@0+1,R27
	STD  Y+@0+2,R24
	STD  Y+@0+3,R25
	.ENDM

	.MACRO __POINTB1MN
	LDI  R30,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW1MN
	LDI  R30,LOW(@0+@1)
	LDI  R31,HIGH(@0+@1)
	.ENDM

	.MACRO __POINTD1M
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __POINTW1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	.ENDM

	.MACRO __POINTD1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	LDI  R22,BYTE3(2*@0+@1)
	LDI  R23,BYTE4(2*@0+@1)
	.ENDM

	.MACRO __POINTB2MN
	LDI  R26,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW2MN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	.ENDM

	.MACRO __POINTBRM
	LDI  R@0,LOW(@1)
	.ENDM

	.MACRO __POINTWRM
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __POINTBRMN
	LDI  R@0,LOW(@1+@2)
	.ENDM

	.MACRO __POINTWRMN
	LDI  R@0,LOW(@2+@3)
	LDI  R@1,HIGH(@2+@3)
	.ENDM

	.MACRO __POINTWRFN
	LDI  R@0,LOW(@2*2+@3)
	LDI  R@1,HIGH(@2*2+@3)
	.ENDM

	.MACRO __GETD1N
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __GETD2N
	LDI  R26,LOW(@0)
	LDI  R27,HIGH(@0)
	LDI  R24,BYTE3(@0)
	LDI  R25,BYTE4(@0)
	.ENDM

	.MACRO __GETD2S
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	LDD  R24,Y+@0+2
	LDD  R25,Y+@0+3
	.ENDM

	.MACRO __GETB1MN
	LDS  R30,@0+@1
	.ENDM

	.MACRO __GETB1HMN
	LDS  R31,@0+@1
	.ENDM

	.MACRO __GETW1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	.ENDM

	.MACRO __GETD1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	LDS  R22,@0+@1+2
	LDS  R23,@0+@1+3
	.ENDM

	.MACRO __GETBRMN
	LDS  R@0,@1+@2
	.ENDM

	.MACRO __GETWRMN
	LDS  R@0,@2+@3
	LDS  R@1,@2+@3+1
	.ENDM

	.MACRO __GETWRZ
	LDD  R@0,Z+@2
	LDD  R@1,Z+@2+1
	.ENDM

	.MACRO __GETD2Z
	LDD  R26,Z+@0
	LDD  R27,Z+@0+1
	LDD  R24,Z+@0+2
	LDD  R25,Z+@0+3
	.ENDM

	.MACRO __GETB2MN
	LDS  R26,@0+@1
	.ENDM

	.MACRO __GETW2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	.ENDM

	.MACRO __GETD2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	LDS  R24,@0+@1+2
	LDS  R25,@0+@1+3
	.ENDM

	.MACRO __PUTB1MN
	STS  @0+@1,R30
	.ENDM

	.MACRO __PUTW1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	.ENDM

	.MACRO __PUTD1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	STS  @0+@1+2,R22
	STS  @0+@1+3,R23
	.ENDM

	.MACRO __PUTBR0MN
	STS  @0+@1,R0
	.ENDM

	.MACRO __PUTDZ2
	STD  Z+@0,R26
	STD  Z+@0+1,R27
	STD  Z+@0+2,R24
	STD  Z+@0+3,R25
	.ENDM

	.MACRO __PUTBMRN
	STS  @0+@1,R@2
	.ENDM

	.MACRO __PUTWMRN
	STS  @0+@1,R@2
	STS  @0+@1+1,R@3
	.ENDM

	.MACRO __PUTBZR
	STD  Z+@1,R@0
	.ENDM

	.MACRO __PUTWZR
	STD  Z+@2,R@0
	STD  Z+@2+1,R@1
	.ENDM

	.MACRO __GETW1R
	MOV  R30,R@0
	MOV  R31,R@1
	.ENDM

	.MACRO __GETW2R
	MOV  R26,R@0
	MOV  R27,R@1
	.ENDM

	.MACRO __GETWRN
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __PUTW1R
	MOV  R@0,R30
	MOV  R@1,R31
	.ENDM

	.MACRO __PUTW2R
	MOV  R@0,R26
	MOV  R@1,R27
	.ENDM

	.MACRO __ADDWRN
	SUBI R@0,LOW(-@2)
	SBCI R@1,HIGH(-@2)
	.ENDM

	.MACRO __ADDWRR
	ADD  R@0,R@2
	ADC  R@1,R@3
	.ENDM

	.MACRO __SUBWRN
	SUBI R@0,LOW(@2)
	SBCI R@1,HIGH(@2)
	.ENDM

	.MACRO __SUBWRR
	SUB  R@0,R@2
	SBC  R@1,R@3
	.ENDM

	.MACRO __ANDWRN
	ANDI R@0,LOW(@2)
	ANDI R@1,HIGH(@2)
	.ENDM

	.MACRO __ANDWRR
	AND  R@0,R@2
	AND  R@1,R@3
	.ENDM

	.MACRO __ORWRN
	ORI  R@0,LOW(@2)
	ORI  R@1,HIGH(@2)
	.ENDM

	.MACRO __ORWRR
	OR   R@0,R@2
	OR   R@1,R@3
	.ENDM

	.MACRO __EORWRR
	EOR  R@0,R@2
	EOR  R@1,R@3
	.ENDM

	.MACRO __GETWRS
	LDD  R@0,Y+@2
	LDD  R@1,Y+@2+1
	.ENDM

	.MACRO __PUTWSR
	STD  Y+@2,R@0
	STD  Y+@2+1,R@1
	.ENDM

	.MACRO __MOVEWRR
	MOV  R@0,R@2
	MOV  R@1,R@3
	.ENDM

	.MACRO __INWR
	IN   R@0,@2
	IN   R@1,@2+1
	.ENDM

	.MACRO __OUTWR
	OUT  @2+1,R@1
	OUT  @2,R@0
	.ENDM

	.MACRO __CALL1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	ICALL
	.ENDM

	.MACRO __CALL1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	RCALL __GETW1PF
	ICALL
	.ENDM

	.MACRO __CALL2EN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	RCALL __EEPROMRDW
	ICALL
	.ENDM

	.MACRO __GETW1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X
	.ENDM

	.MACRO __NBST
	BST  R@0,@1
	IN   R30,SREG
	LDI  R31,0x40
	EOR  R30,R31
	OUT  SREG,R30
	.ENDM


	.MACRO __PUTB1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RNS
	MOVW R26,R@0
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	RCALL __PUTDP1
	.ENDM


	.MACRO __GETB1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R30,Z
	.ENDM

	.MACRO __GETB1HSX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	.ENDM

	.MACRO __GETW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z+
	LD   R23,Z
	MOVW R30,R0
	.ENDM

	.MACRO __GETB2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R26,X
	.ENDM

	.MACRO __GETW2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	.ENDM

	.MACRO __GETD2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R1,X+
	LD   R24,X+
	LD   R25,X
	MOVW R26,R0
	.ENDM

	.MACRO __GETBRSX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	LD   R@0,Z
	.ENDM

	.MACRO __GETWRSX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	LD   R@0,Z+
	LD   R@1,Z
	.ENDM

	.MACRO __LSLW8SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	CLR  R30
	.ENDM

	.MACRO __PUTB1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __CLRW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	CLR  R0
	ST   Z+,R0
	ST   Z,R0
	.ENDM

	.MACRO __CLRD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	CLR  R0
	ST   Z+,R0
	ST   Z+,R0
	ST   Z+,R0
	ST   Z,R0
	.ENDM

	.MACRO __PUTB2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R26
	.ENDM

	.MACRO __PUTW2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z,R27
	.ENDM

	.MACRO __PUTD2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z+,R27
	ST   Z+,R24
	ST   Z,R25
	.ENDM

	.MACRO __PUTBSRX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R@1
	.ENDM

	.MACRO __PUTWSRX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	ST   Z+,R@0
	ST   Z,R@1
	.ENDM

	.MACRO __PUTB1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __MULBRR
	MULS R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRRU
	MUL  R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRR0
	MULS R@0,R@1
	.ENDM

	.MACRO __MULBRRU0
	MUL  R@0,R@1
	.ENDM

	.MACRO __MULBNWRU
	LDI  R26,@2
	MUL  R26,R@0
	MOVW R30,R0
	MUL  R26,R@1
	ADD  R31,R0
	.ENDM

	.CSEG
	.ORG 0

	.INCLUDE "watt.vec"
	.INCLUDE "watt.inc"

__RESET:
	CLI
	CLR  R30
	OUT  EECR,R30

;INTERRUPT VECTORS ARE PLACED
;AT THE START OF FLASH
	LDI  R31,1
	OUT  MCUCR,R31
	OUT  MCUCR,R30

;DISABLE WATCHDOG
	LDI  R31,0x18
	WDR
	IN   R26,MCUSR
	CBR  R26,8
	OUT  MCUSR,R26
	STS  WDTCSR,R31
	STS  WDTCSR,R30

;CLEAR R2-R14
	LDI  R24,13
	LDI  R26,2
	CLR  R27
__CLEAR_REG:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_REG

;CLEAR SRAM
	LDI  R24,LOW(0x400)
	LDI  R25,HIGH(0x400)
	LDI  R26,LOW(0x100)
	LDI  R27,HIGH(0x100)
__CLEAR_SRAM:
	ST   X+,R30
	SBIW R24,1
	BRNE __CLEAR_SRAM

;GLOBAL VARIABLES INITIALIZATION
	LDI  R30,LOW(__GLOBAL_INI_TBL*2)
	LDI  R31,HIGH(__GLOBAL_INI_TBL*2)
__GLOBAL_INI_NEXT:
	LPM  R24,Z+
	LPM  R25,Z+
	SBIW R24,0
	BREQ __GLOBAL_INI_END
	LPM  R26,Z+
	LPM  R27,Z+
	LPM  R0,Z+
	LPM  R1,Z+
	MOVW R22,R30
	MOVW R30,R0
__GLOBAL_INI_LOOP:
	LPM  R0,Z+
	ST   X+,R0
	SBIW R24,1
	BRNE __GLOBAL_INI_LOOP
	MOVW R30,R22
	RJMP __GLOBAL_INI_NEXT
__GLOBAL_INI_END:

;GPIOR0 INITIALIZATION
	LDI  R30,__GPIOR0_INIT
	OUT  GPIOR0,R30

;STACK POINTER INITIALIZATION
	LDI  R30,LOW(0x4FF)
	OUT  SPL,R30
	LDI  R30,HIGH(0x4FF)
	OUT  SPH,R30

;DATA STACK POINTER INITIALIZATION
	LDI  R28,LOW(0x200)
	LDI  R29,HIGH(0x200)

	RJMP _main

	.ESEG
	.ORG 0

	.DSEG
	.ORG 0x200
;       1 #include <init.h>
;       2 	#ifndef __SLEEP_DEFINED__
	#ifndef __SLEEP_DEFINED__
;       3 	#define __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
;       4 	.EQU __se_bit=0x01
	.EQU __se_bit=0x01
;       5 	.EQU __sm_mask=0x0E
	.EQU __sm_mask=0x0E
;       6 	.EQU __sm_adc_noise_red=0x02
	.EQU __sm_adc_noise_red=0x02
;       7 	.EQU __sm_powerdown=0x04
	.EQU __sm_powerdown=0x04
;       8 	.EQU __sm_powersave=0x06
	.EQU __sm_powersave=0x06
;       9 	.EQU __sm_standby=0x0C
	.EQU __sm_standby=0x0C
;      10 	.SET power_ctrl_reg=smcr
	.SET power_ctrl_reg=smcr
;      11 	#endif
	#endif
;      12    .equ __lcd_port=0x0B ;PORTD
   .equ __lcd_port=0x0B ;PORTD
_volt_accum:
	.BYTE 0x4
_amp_accum:
	.BYTE 0x4
_average_volt_accum:
	.BYTE 0x4
_average_amp_accum:
	.BYTE 0x4
_amp:
	.BYTE 0x2
_average_volt:
	.BYTE 0x2
_average_amp:
	.BYTE 0x2
_average_period_accum:
	.BYTE 0x2
_average_period:
	.BYTE 0x2
_measure_time_counter:
	.BYTE 0x1
_power:
	.BYTE 0x4
_active:
	.BYTE 0x4
_reactive:
	.BYTE 0x4
_cosinus:
	.BYTE 0x4
_sinus:
	.BYTE 0x4
_buttons_counter:
	.BYTE 0x1
_menu_num:
	.BYTE 0x1
_max_amp:
	.BYTE 0x2
_max_volt:
	.BYTE 0x2
_tact:
	.BYTE 0x2
_max_amp_tact:
	.BYTE 0x2
_max_volt_tact:
	.BYTE 0x2

	.CSEG
_freq_start:
	RCALL SUBOPT_0x0
	LDI  R30,LOW(5)
	STS  129,R30
	LDI  R30,0
	STS  _max_amp,R30
	STS  _max_amp+1,R30
	LDI  R30,0
	STS  _max_volt,R30
	STS  _max_volt+1,R30
	LDI  R30,0
	STS  _tact,R30
	STS  _tact+1,R30
	RET
_freq_stop:
	LDI  R30,LOW(0)
	STS  129,R30
	__GETWRMN 9,10,0,132
	RCALL SUBOPT_0x0
	RET
_volt_amp_calc:
	MOV  R30,R7
	RCALL SUBOPT_0x1
	RCALL SUBOPT_0x2
	__PUTW1R 13,14
	MOV  R30,R12
	RCALL SUBOPT_0x3
	RCALL SUBOPT_0x2
	STS  _amp,R30
	STS  _amp+1,R31
	LDI  R30,0
	STS  _volt_accum,R30
	STS  _volt_accum+1,R30
	STS  _volt_accum+2,R30
	STS  _volt_accum+3,R30
	LDI  R30,0
	STS  _amp_accum,R30
	STS  _amp_accum+1,R30
	STS  _amp_accum+2,R30
	STS  _amp_accum+3,R30
	CLR  R7
	CLR  R12
	LDI  R30,LOW(16)
	CP   R30,R11
	BRNE _0x3
	CLR  R11
	RCALL SUBOPT_0x4
	LDI  R30,LOW(3)
	RCALL __LSRD12
	STS  _average_volt,R30
	STS  _average_volt+1,R31
	RCALL SUBOPT_0x5
	LDI  R30,LOW(3)
	RCALL __LSRD12
	STS  _average_amp,R30
	STS  _average_amp+1,R31
	LDS  R30,_average_period_accum
	LDS  R31,_average_period_accum+1
	RCALL __LSRW4
	STS  _average_period,R30
	STS  _average_period+1,R31
	LDI  R30,0
	STS  _average_volt_accum,R30
	STS  _average_volt_accum+1,R30
	STS  _average_volt_accum+2,R30
	STS  _average_volt_accum+3,R30
	LDI  R30,0
	STS  _average_amp_accum,R30
	STS  _average_amp_accum+1,R30
	STS  _average_amp_accum+2,R30
	STS  _average_amp_accum+3,R30
	LDI  R30,0
	STS  _average_period_accum,R30
	STS  _average_period_accum+1,R30
	SBI  0x1E,0
	RJMP _0x6
_0x3:
	INC  R11
	__GETW1R 13,14
	RCALL SUBOPT_0x4
	RCALL SUBOPT_0x6
	STS  _average_volt_accum,R30
	STS  _average_volt_accum+1,R31
	STS  _average_volt_accum+2,R22
	STS  _average_volt_accum+3,R23
	LDS  R30,_amp
	LDS  R31,_amp+1
	RCALL SUBOPT_0x5
	RCALL SUBOPT_0x6
	STS  _average_amp_accum,R30
	STS  _average_amp_accum+1,R31
	STS  _average_amp_accum+2,R22
	STS  _average_amp_accum+3,R23
	__GETW1R 9,10
	LDS  R26,_average_period_accum
	LDS  R27,_average_period_accum+1
	ADD  R30,R26
	ADC  R31,R27
	STS  _average_period_accum,R30
	STS  _average_period_accum+1,R31
_0x6:
	RET
_check_metering:
	SBIC 0x1E,2
	RJMP _0x7
	SBI  0x1E,2
	RCALL _freq_start
	RJMP _0xA
_0x7:
	CBI  0x1E,2
	RCALL _freq_stop
	RCALL _volt_amp_calc
	CBI  0x1E,1
_0xA:
	RET
_float_out:
	SBIW R28,5
;	f -> Y+6
;	digits -> Y+5
;	mas -> Y+0
	__GETD1S 6
	RCALL __PUTPARD1
	LDD  R30,Y+9
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,5
	RCALL SUBOPT_0x7
	RCALL _ftoa
	RCALL SUBOPT_0x8
	RCALL SUBOPT_0x9
	RCALL __CMPF12
	BRSH _0xF
	RCALL SUBOPT_0xA
	RCALL SUBOPT_0xA
	RJMP _0x71
_0xF:
	RCALL SUBOPT_0x8
	__GETD1N 0x42C80000
	RCALL __CMPF12
	BRSH _0x11
	RCALL SUBOPT_0xA
	RJMP _0x71
_0x11:
	RCALL SUBOPT_0x8
	__GETD1N 0x447A0000
	RCALL __CMPF12
	BRSH _0x13
_0x71:
	LDI  R30,LOW(32)
	ST   -Y,R30
	RCALL _lcd_putchar
	MOVW R30,R28
	RCALL SUBOPT_0x7
	RCALL _lcd_puts
_0x13:
	LDD  R30,Y+5
	CPI  R30,0
	BRNE _0x14
	RCALL SUBOPT_0xA
	RCALL SUBOPT_0xA
	RCALL SUBOPT_0xA
	RCALL SUBOPT_0xA
_0x14:
	LDD  R26,Y+5
	CPI  R26,LOW(0x1)
	BRNE _0x15
	RCALL SUBOPT_0xA
	RCALL SUBOPT_0xA
_0x15:
	LDD  R26,Y+5
	CPI  R26,LOW(0x2)
	BRNE _0x16
	RCALL SUBOPT_0xA
_0x16:
	ADIW R28,10
	RET
_volt_amp:
	SBIW R28,4
;	f -> Y+0
	LDS  R30,_average_volt
	LDS  R31,_average_volt+1
	RCALL SUBOPT_0xB
	__GETD1N 0x3EBE425B
	RCALL SUBOPT_0xC
	RCALL SUBOPT_0xD
	RCALL SUBOPT_0xE
	RCALL SUBOPT_0xB
	__GETD1N 0x3C851EB8
	RCALL SUBOPT_0xC
	LDS  R26,_power
	LDS  R27,_power+1
	LDS  R24,_power+2
	LDS  R25,_power+3
	RCALL __MULF12
	RCALL SUBOPT_0xD
	RJMP _0x70
_pow_fact:
	SBIW R28,9
	RCALL __SAVELOCR2
;	mas -> Y+6
;	i -> R16,R17
;	f -> Y+2
	RCALL SUBOPT_0xE
	SBIW R30,0
	BRNE _0x17
	RCALL SUBOPT_0xF
	RCALL SUBOPT_0x10
_0x17:
	RCALL SUBOPT_0xF
	RCALL SUBOPT_0x11
	CP   R30,R26
	CPC  R31,R27
	BRSH _0x18
	LDS  R26,_max_amp_tact
	LDS  R27,_max_amp_tact+1
	LDS  R30,_max_volt_tact
	LDS  R31,_max_volt_tact+1
	RJMP _0x72
_0x18:
	RCALL SUBOPT_0x11
	RCALL SUBOPT_0xF
_0x72:
	SUB  R30,R26
	SBC  R31,R27
	MOVW R16,R30
	MOVW R30,R16
	RCALL __CWD1
	RCALL __CDF1
	RCALL SUBOPT_0x12
	RCALL SUBOPT_0x13
	__GETD1N 0x43110000
	RCALL __DIVF21
	RCALL SUBOPT_0x14
	__GETD2N 0x40C8F5C3
	RCALL __MULF12
	RCALL SUBOPT_0x14
	RCALL __PUTPARD1
	RCALL _cos
	STS  _cosinus,R30
	STS  _cosinus+1,R31
	STS  _cosinus+2,R22
	STS  _cosinus+3,R23
	RCALL SUBOPT_0x15
	RCALL __PUTPARD1
	RCALL _sin
	STS  _sinus,R30
	STS  _sinus+1,R31
	STS  _sinus+2,R22
	STS  _sinus+3,R23
	RCALL SUBOPT_0x16
	RCALL SUBOPT_0x17
	LDS  R30,_cosinus
	LDS  R31,_cosinus+1
	LDS  R22,_cosinus+2
	LDS  R23,_cosinus+3
	RCALL SUBOPT_0x18
	RCALL __LOADLOCR2
	ADIW R28,11
	RET
_active_passive:
	RCALL SUBOPT_0x16
	LDS  R26,_cosinus
	LDS  R27,_cosinus+1
	LDS  R24,_cosinus+2
	LDS  R25,_cosinus+3
	RCALL __MULF12
	STS  _active,R30
	STS  _active+1,R31
	STS  _active+2,R22
	STS  _active+3,R23
	RCALL SUBOPT_0x16
	LDS  R26,_sinus
	LDS  R27,_sinus+1
	LDS  R24,_sinus+2
	LDS  R25,_sinus+3
	RCALL __MULF12
	STS  _reactive,R30
	STS  _reactive+1,R31
	STS  _reactive+2,R22
	STS  _reactive+3,R23
	LDS  R30,_active
	LDS  R31,_active+1
	LDS  R22,_active+2
	LDS  R23,_active+3
	RCALL SUBOPT_0x17
	LDS  R30,_reactive
	LDS  R31,_reactive+1
	LDS  R22,_reactive+2
	LDS  R23,_reactive+3
	RCALL SUBOPT_0x17
	RET
_freq:
	SBIW R28,4
;	f -> Y+0
	__GETD1N 0x46610000
	RCALL SUBOPT_0x19
	LDS  R30,_average_period
	LDS  R31,_average_period+1
	RCALL SUBOPT_0x1A
	CLR  R22
	CLR  R23
	RCALL __CDF1
	RCALL __DIVF21
	RCALL SUBOPT_0x19
	__GETD1S 0
	RCALL SUBOPT_0x18
_0x70:
	ADIW R28,4
	RET
_lcd_refresh:
	SBIW R28,9
;	mas -> Y+4
;	f -> Y+0
	CBI  0x1E,0
	RCALL _lcd_clear
	SBIS 0x1E,4
	RJMP _0x1C
	CBI  0x1E,4
	RCALL _lcd_clear
	LDS  R30,_menu_num
	CPI  R30,0
	BRNE _0x22
	__POINTW1FN _0,0
	RCALL SUBOPT_0x7
	RCALL _lcd_putsf
	__POINTW1FN _0,9
	RJMP _0x73
_0x22:
	CPI  R30,LOW(0x1)
	BRNE _0x23
	__POINTW1FN _0,18
	RCALL SUBOPT_0x7
	RCALL _lcd_putsf
	__POINTW1FN _0,27
	RJMP _0x73
_0x23:
	CPI  R30,LOW(0x2)
	BRNE _0x24
	__POINTW1FN _0,36
	RCALL SUBOPT_0x7
	RCALL _lcd_putsf
	__POINTW1FN _0,45
	RJMP _0x73
_0x24:
	CPI  R30,LOW(0x3)
	BRNE _0x21
	__POINTW1FN _0,54
_0x73:
	ST   -Y,R31
	ST   -Y,R30
	RCALL _lcd_putsf
_0x21:
	LDI  R30,LOW(1500)
	LDI  R31,HIGH(1500)
	RCALL SUBOPT_0x7
	RCALL _delay_ms
	RCALL _lcd_clear
_0x1C:
	LDS  R30,_menu_num
	CPI  R30,0
	BRNE _0x29
	RCALL _volt_amp
	RJMP _0x28
_0x29:
	CPI  R30,LOW(0x1)
	BRNE _0x2A
	RCALL _pow_fact
	RJMP _0x28
_0x2A:
	CPI  R30,LOW(0x2)
	BRNE _0x2B
	RCALL _active_passive
	RJMP _0x28
_0x2B:
	CPI  R30,LOW(0x3)
	BRNE _0x28
	RCALL _freq
_0x28:
	ADIW R28,9
	RET
_init:
	LDI  R30,LOW(128)
	STS  97,R30
	LDI  R30,LOW(0)
	STS  97,R30
	OUT  0x5,R30
	LDI  R30,LOW(32)
	OUT  0x4,R30
	LDI  R30,LOW(28)
	OUT  0x8,R30
	LDI  R30,LOW(0)
	OUT  0x7,R30
	OUT  0xB,R30
	OUT  0xA,R30
	OUT  0x24,R30
	LDI  R30,LOW(4)
	OUT  0x25,R30
	LDI  R30,LOW(0)
	OUT  0x26,R30
	OUT  0x27,R30
	OUT  0x28,R30
	STS  128,R30
	STS  129,R30
	STS  133,R30
	STS  132,R30
	STS  135,R30
	STS  134,R30
	STS  137,R30
	STS  136,R30
	STS  139,R30
	STS  138,R30
	STS  182,R30
	STS  176,R30
	LDI  R30,LOW(2)
	STS  177,R30
	LDI  R30,LOW(0)
	STS  178,R30
	LDI  R30,LOW(240)
	STS  179,R30
	LDI  R30,LOW(0)
	STS  180,R30
	LDI  R30,LOW(8)
	STS  105,R30
	LDI  R30,LOW(2)
	OUT  0x1D,R30
	OUT  0x1C,R30
	LDI  R30,LOW(0)
	STS  104,R30
	LDI  R30,LOW(1)
	STS  110,R30
	LDI  R30,LOW(0)
	STS  111,R30
	LDI  R30,LOW(2)
	STS  112,R30
	LDI  R30,LOW(128)
	OUT  0x30,R30
	LDI  R30,LOW(0)
	STS  123,R30
	STS  126,R30
	LDI  R30,LOW(192)
	STS  124,R30
	LDI  R30,LOW(143)
	STS  122,R30
	LDI  R30,LOW(1000)
	LDI  R31,HIGH(1000)
	RCALL SUBOPT_0x7
	RCALL _delay_ms
	LDI  R30,LOW(8)
	ST   -Y,R30
	RCALL _lcd_init
	sei
	RET
;      13 
;      14 interrupt [EXT_INT1] void ext_int1_isr(void) //    
;      15 {
_ext_int1_isr:
	RCALL SUBOPT_0x1B
;      16     if(measure_start==TRUE)
	SBIC 0x1E,1
;      17     {
;      18         check_metering();
	RCALL _check_metering
;      19     }
;      20 }
	RJMP _0x76
;      21 
;      22 
;      23 
;      24 void buttons_timer_routine(void)
;      25 {
_buttons_timer_routine:
;      26       if(buttons_timer==TRUE)//  , 
	SBIS 0x1E,3
	RJMP _0x2E
;      27       {
;      28             if(buttons_counter==110) // 1 
	LDS  R26,_buttons_counter
	CPI  R26,LOW(0x6E)
	BRNE _0x2F
;      29             {
;      30                 buttons_counter=0;
	LDI  R30,LOW(0)
	STS  _buttons_counter,R30
;      31                 buttons_timer=FALSE;
	CBI  0x1E,3
;      32             }
;      33             else buttons_counter++;
	RJMP _0x32
_0x2F:
	LDS  R30,_buttons_counter
	SUBI R30,-LOW(1)
	STS  _buttons_counter,R30
;      34       }
_0x32:
;      35       else
	RJMP _0x33
_0x2E:
;      36       {
;      37           if(BUTTON2==0)
	SBIC 0x6,3
	RJMP _0x34
;      38           {
;      39                 if(menu_num==3)menu_num=0;
	LDS  R26,_menu_num
	CPI  R26,LOW(0x3)
	BRNE _0x35
	LDI  R30,LOW(0)
	RJMP _0x74
;      40                 else menu_num++;
_0x35:
	LDS  R30,_menu_num
	SUBI R30,-LOW(1)
_0x74:
	STS  _menu_num,R30
;      41                 buttons_timer=TRUE;
	SBI  0x1E,3
;      42                 new_menu=TRUE;
	SBI  0x1E,4
;      43                 display_changed=TRUE;
	SBI  0x1E,0
;      44           }
;      45 
;      46       }
_0x34:
_0x33:
;      47 
;      48 
;      49 }
	RET
;      50 
;      51 
;      52 
;      53 interrupt [TIM0_OVF] void timer0_ovf_isr(void) //   225   
;      54 {
_timer0_ovf_isr:
	RCALL SUBOPT_0x1B
;      55     buttons_timer_routine();
	RCALL _buttons_timer_routine
;      56 
;      57     if(measure_time_counter==25){if(measure_start==FALSE)measure_start=TRUE; measure_time_counter=0;} //   9   .
	LDS  R26,_measure_time_counter
	CPI  R26,LOW(0x19)
	BRNE _0x3D
	SBIS 0x1E,1
	SBI  0x1E,1
	LDI  R30,LOW(0)
	RJMP _0x75
;      58     else measure_time_counter++;
_0x3D:
	LDS  R30,_measure_time_counter
	SUBI R30,-LOW(1)
_0x75:
	STS  _measure_time_counter,R30
;      59 
;      60     if(second_counter==225)
	LDI  R30,LOW(225)
	CP   R30,R4
	BRNE _0x42
;      61     {
;      62         second_counter=0;
	CLR  R4
;      63         seconds++;
	INC  R3
;      64     }
;      65     else second_counter++;
	RJMP _0x43
_0x42:
	INC  R4
;      66 
;      67     if(seconds==60){minutes++;seconds=0;}else return;
_0x43:
	LDI  R30,LOW(60)
	CP   R30,R3
	BRNE _0x44
	INC  R6
	CLR  R3
	RJMP _0x45
_0x44:
	RJMP _0x76
;      68     if(minutes==60){hours++;minutes=0;}else return;
_0x45:
	LDI  R30,LOW(60)
	CP   R30,R6
	BRNE _0x46
	INC  R5
	CLR  R6
	RJMP _0x47
_0x46:
	RJMP _0x76
;      69     if(hours==24){days++;hours=0;}
_0x47:
	LDI  R30,LOW(24)
	CP   R30,R5
	BRNE _0x48
	INC  R8
	CLR  R5
;      70 }
_0x48:
_0x76:
	LD   R30,Y+
	OUT  SREG,R30
	LD   R31,Y+
	LD   R30,Y+
	LD   R27,Y+
	LD   R26,Y+
	LD   R25,Y+
	LD   R24,Y+
	LD   R23,Y+
	LD   R22,Y+
	LD   R15,Y+
	LD   R1,Y+
	LD   R0,Y+
	RETI
;      71 
;      72 
;      73 interrupt [TIM2_COMPA] void timer2_compa_isr(void) //
;      74 {
_timer2_compa_isr:
	ST   -Y,R30
;      75     if(timer_started==TRUE)ADCSRA=0b11001110;//  
	SBIS 0x1E,2
	RJMP _0x49
	LDI  R30,LOW(206)
	STS  122,R30
;      76 }
_0x49:
	LD   R30,Y+
	RETI
;      77 
;      78 
;      79 
;      80 interrupt [ADC_INT] void adc_isr(void)
;      81 {
_adc_isr:
	ST   -Y,R22
	ST   -Y,R23
	ST   -Y,R24
	ST   -Y,R25
	ST   -Y,R26
	ST   -Y,R27
	ST   -Y,R30
	ST   -Y,R31
	IN   R30,SREG
	ST   -Y,R30
;      82     unsigned int adc_data;
;      83     adc_data=ADCW;
	RCALL __SAVELOCR2
;	adc_data -> R16,R17
	__GETWRMN 16,17,0,120
;      84 
;      85     if(ADMUX==0b00000001)//
	LDS  R26,124
	CPI  R26,LOW(0x1)
	BRNE _0x4A
;      86     {
;      87         ADMUX=0b00000000; //  
	LDI  R30,LOW(0)
	STS  124,R30
;      88         volt_measures++;
	INC  R7
;      89         volt_accum=volt_accum+adc_data;
	MOVW R30,R16
	RCALL SUBOPT_0x1
	RCALL SUBOPT_0x6
	STS  _volt_accum,R30
	STS  _volt_accum+1,R31
	STS  _volt_accum+2,R22
	STS  _volt_accum+3,R23
;      90 
;      91         if(adc_data>max_volt){max_volt=adc_data; max_volt_tact=tact;}
	LDS  R30,_max_volt
	LDS  R31,_max_volt+1
	CP   R30,R16
	CPC  R31,R17
	BRSH _0x4B
	__PUTWMRN _max_volt,0,16,17
	RCALL SUBOPT_0x1C
	RCALL SUBOPT_0x10
;      92 
;      93     }
_0x4B:
;      94     else// 
	RJMP _0x4C
_0x4A:
;      95     {
;      96         ADMUX=0b00000001; //  
	LDI  R30,LOW(1)
	STS  124,R30
;      97         amp_measures++;
	INC  R12
;      98         amp_accum=amp_accum+adc_data;
	MOVW R30,R16
	RCALL SUBOPT_0x3
	RCALL SUBOPT_0x6
	STS  _amp_accum,R30
	STS  _amp_accum+1,R31
	STS  _amp_accum+2,R22
	STS  _amp_accum+3,R23
;      99 
;     100         if(adc_data>max_amp){max_amp=adc_data; max_amp_tact=tact;}
	LDS  R30,_max_amp
	LDS  R31,_max_amp+1
	CP   R30,R16
	CPC  R31,R17
	BRSH _0x4D
	__PUTWMRN _max_amp,0,16,17
	RCALL SUBOPT_0x1C
	STS  _max_amp_tact,R30
	STS  _max_amp_tact+1,R31
;     101 
;     102     }
_0x4D:
_0x4C:
;     103 
;     104     tact++;
	RCALL SUBOPT_0x1C
	ADIW R30,1
	STS  _tact,R30
	STS  _tact+1,R31
;     105 
;     106 }
	RCALL __LOADLOCR2P
	LD   R30,Y+
	OUT  SREG,R30
	LD   R31,Y+
	LD   R30,Y+
	LD   R27,Y+
	LD   R26,Y+
	LD   R25,Y+
	LD   R24,Y+
	LD   R23,Y+
	LD   R22,Y+
	RETI
;     107 
;     108 
;     109 void main(void)
;     110 {
_main:
;     111     init();
	RCALL _init
;     112 
;     113     while (1)
_0x4E:
;     114     {
;     115           if(display_changed==TRUE)lcd_refresh();
	SBIC 0x1E,0
	RCALL _lcd_refresh
;     116     };
	RJMP _0x4E
;     117 }
_0x52:
	RJMP _0x52

    .equ __lcd_direction=__lcd_port-1
    .equ __lcd_pin=__lcd_port-2
    .equ __lcd_rs=0
    .equ __lcd_rd=1
    .equ __lcd_enable=2
    .equ __lcd_busy_flag=7

	.DSEG
__base_y_G2:
	.BYTE 0x4
__lcd_x:
	.BYTE 0x1
__lcd_y:
	.BYTE 0x1
__lcd_maxx:
	.BYTE 0x1

	.CSEG
__lcd_delay_G2:
    ldi   r31,15
__lcd_delay0:
    dec   r31
    brne  __lcd_delay0
	RET
__lcd_ready:
    in    r26,__lcd_direction
    andi  r26,0xf                 ;set as input
    out   __lcd_direction,r26
    sbi   __lcd_port,__lcd_rd     ;RD=1
    cbi   __lcd_port,__lcd_rs     ;RS=0
__lcd_busy:
	RCALL __lcd_delay_G2
    sbi   __lcd_port,__lcd_enable ;EN=1
	RCALL __lcd_delay_G2
    in    r26,__lcd_pin
    cbi   __lcd_port,__lcd_enable ;EN=0
	RCALL __lcd_delay_G2
    sbi   __lcd_port,__lcd_enable ;EN=1
	RCALL __lcd_delay_G2
    cbi   __lcd_port,__lcd_enable ;EN=0
    sbrc  r26,__lcd_busy_flag
    rjmp  __lcd_busy
	RET
__lcd_write_nibble_G2:
    andi  r26,0xf0
    or    r26,r27
    out   __lcd_port,r26          ;write
    sbi   __lcd_port,__lcd_enable ;EN=1
	RCALL __lcd_delay_G2
    cbi   __lcd_port,__lcd_enable ;EN=0
	RCALL __lcd_delay_G2
	RET
__lcd_write_data:
    cbi  __lcd_port,__lcd_rd 	  ;RD=0
    in    r26,__lcd_direction
    ori   r26,0xf0 | (1<<__lcd_rs) | (1<<__lcd_rd) | (1<<__lcd_enable) ;set as output    
    out   __lcd_direction,r26
    in    r27,__lcd_port
    andi  r27,0xf
    ld    r26,y
	RCALL __lcd_write_nibble_G2
    ld    r26,y
    swap  r26
	RCALL __lcd_write_nibble_G2
    sbi   __lcd_port,__lcd_rd     ;RD=1
	ADIW R28,1
	RET
__lcd_read_nibble_G2:
    sbi   __lcd_port,__lcd_enable ;EN=1
	RCALL __lcd_delay_G2
    in    r30,__lcd_pin           ;read
    cbi   __lcd_port,__lcd_enable ;EN=0
	RCALL __lcd_delay_G2
    andi  r30,0xf0
	RET
_lcd_read_byte0_G2:
	RCALL __lcd_delay_G2
	RCALL __lcd_read_nibble_G2
    mov   r26,r30
	RCALL __lcd_read_nibble_G2
    cbi   __lcd_port,__lcd_rd     ;RD=0
    swap  r30
    or    r30,r26
	RET
_lcd_gotoxy:
	RCALL __lcd_ready
	LD   R30,Y
	LDI  R31,0
	SUBI R30,LOW(-__base_y_G2)
	SBCI R31,HIGH(-__base_y_G2)
	LD   R30,Z
	LDD  R26,Y+1
	ADD  R30,R26
	RCALL SUBOPT_0x1D
	LDD  R30,Y+1
	STS  __lcd_x,R30
	LD   R30,Y
	STS  __lcd_y,R30
	ADIW R28,2
	RET
_lcd_clear:
	RCALL __lcd_ready
	LDI  R30,LOW(2)
	RCALL SUBOPT_0x1D
	RCALL __lcd_ready
	LDI  R30,LOW(12)
	RCALL SUBOPT_0x1D
	RCALL __lcd_ready
	LDI  R30,LOW(1)
	RCALL SUBOPT_0x1D
	LDI  R30,LOW(0)
	STS  __lcd_y,R30
	STS  __lcd_x,R30
	RET
_lcd_putchar:
    push r30
    push r31
    ld   r26,y
    set
    cpi  r26,10
    breq __lcd_putchar1
    clt
	LDS  R30,__lcd_x
	SUBI R30,-LOW(1)
	STS  __lcd_x,R30
	LDS  R30,__lcd_maxx
	LDS  R26,__lcd_x
	CP   R30,R26
	BRSH _0x54
	__lcd_putchar1:
	LDS  R30,__lcd_y
	SUBI R30,-LOW(1)
	STS  __lcd_y,R30
	LDI  R30,LOW(0)
	ST   -Y,R30
	LDS  R30,__lcd_y
	ST   -Y,R30
	RCALL _lcd_gotoxy
	brts __lcd_putchar0
_0x54:
    rcall __lcd_ready
    sbi  __lcd_port,__lcd_rs ;RS=1
    ld   r26,y
    st   -y,r26
    rcall __lcd_write_data
__lcd_putchar0:
    pop  r31
    pop  r30
	ADIW R28,1
	RET
_lcd_puts:
	ST   -Y,R17
_0x55:
	LDD  R26,Y+1
	LDD  R27,Y+1+1
	LD   R30,X+
	STD  Y+1,R26
	STD  Y+1+1,R27
	MOV  R17,R30
	CPI  R30,0
	BREQ _0x57
	ST   -Y,R17
	RCALL _lcd_putchar
	RJMP _0x55
_0x57:
	LDD  R17,Y+0
	RJMP _0x6F
_lcd_putsf:
	ST   -Y,R17
_0x58:
	LDD  R30,Y+1
	LDD  R31,Y+1+1
	ADIW R30,1
	STD  Y+1,R30
	STD  Y+1+1,R31
	SBIW R30,1
	LPM  R30,Z
	MOV  R17,R30
	CPI  R30,0
	BREQ _0x5A
	ST   -Y,R17
	RCALL _lcd_putchar
	RJMP _0x58
_0x5A:
	LDD  R17,Y+0
_0x6F:
	ADIW R28,3
	RET
__long_delay_G2:
    clr   r26
    clr   r27
__long_delay0:
    sbiw  r26,1         ;2 cycles
    brne  __long_delay0 ;2 cycles
	RET
__lcd_init_write_G2:
    cbi  __lcd_port,__lcd_rd 	  ;RD=0
    in    r26,__lcd_direction
    ori   r26,0xf7                ;set as output
    out   __lcd_direction,r26
    in    r27,__lcd_port
    andi  r27,0xf
    ld    r26,y
	RCALL __lcd_write_nibble_G2
    sbi   __lcd_port,__lcd_rd     ;RD=1
	ADIW R28,1
	RET
_lcd_init:
    cbi   __lcd_port,__lcd_enable ;EN=0
    cbi   __lcd_port,__lcd_rs     ;RS=0
	LD   R30,Y
	STS  __lcd_maxx,R30
	SUBI R30,-LOW(128)
	__PUTB1MN __base_y_G2,2
	LD   R30,Y
	SUBI R30,-LOW(192)
	__PUTB1MN __base_y_G2,3
	RCALL SUBOPT_0x1E
	RCALL SUBOPT_0x1E
	RCALL SUBOPT_0x1E
	RCALL __long_delay_G2
	LDI  R30,LOW(32)
	ST   -Y,R30
	RCALL __lcd_init_write_G2
	RCALL __long_delay_G2
	LDI  R30,LOW(40)
	RCALL SUBOPT_0x1D
	RCALL __long_delay_G2
	LDI  R30,LOW(4)
	RCALL SUBOPT_0x1D
	RCALL __long_delay_G2
	LDI  R30,LOW(133)
	RCALL SUBOPT_0x1D
	RCALL __long_delay_G2
    in    r26,__lcd_direction
    andi  r26,0xf                 ;set as input
    out   __lcd_direction,r26
    sbi   __lcd_port,__lcd_rd     ;RD=1
	RCALL _lcd_read_byte0_G2
	CPI  R30,LOW(0x5)
	BREQ _0x5B
	LDI  R30,LOW(0)
	RJMP _0x6E
_0x5B:
	RCALL __lcd_ready
	LDI  R30,LOW(6)
	RCALL SUBOPT_0x1D
	RCALL _lcd_clear
	LDI  R30,LOW(1)
_0x6E:
	ADIW R28,1
	RET
_ftoa:
	SBIW R28,4
	RCALL __SAVELOCR2
	RCALL SUBOPT_0x1F
	RCALL __CPD20
	BRGE _0x5C
	RCALL SUBOPT_0x20
	RCALL __ANEGF1
	RCALL SUBOPT_0x21
	RCALL SUBOPT_0x22
	LDI  R30,LOW(45)
	ST   X,R30
_0x5C:
	LDD  R26,Y+8
	CPI  R26,LOW(0x7)
	BRLO _0x5D
	LDI  R30,LOW(6)
	STD  Y+8,R30
_0x5D:
	LDD  R30,Y+8
	LDI  R26,LOW(__fround_G3*2)
	LDI  R27,HIGH(__fround_G3*2)
	LDI  R31,0
	RCALL __LSLW2
	ADD  R30,R26
	ADC  R31,R27
	RCALL __GETD1PF
	RCALL SUBOPT_0x1F
	RCALL __ADDF12
	RCALL SUBOPT_0x21
	LDI  R17,LOW(0)
	__GETD1N 0x3F800000
	RCALL SUBOPT_0x12
_0x5E:
	RCALL SUBOPT_0x15
	RCALL SUBOPT_0x1F
	RCALL __CMPF12
	BRLO _0x60
	RCALL SUBOPT_0x13
	RCALL SUBOPT_0x9
	RCALL __MULF12
	RCALL SUBOPT_0x12
	SUBI R17,-LOW(1)
	RJMP _0x5E
_0x60:
	CPI  R17,0
	BRNE _0x61
	RCALL SUBOPT_0x22
	LDI  R30,LOW(48)
	ST   X,R30
	RJMP _0x62
_0x61:
_0x63:
	MOV  R30,R17
	SUBI R17,1
	CPI  R30,0
	BREQ _0x65
	RCALL SUBOPT_0x13
	RCALL SUBOPT_0x9
	RCALL __DIVF21
	__GETD2N 0x3F000000
	RCALL __ADDF12
	RCALL __PUTPARD1
	RCALL _floor
	RCALL SUBOPT_0x14
	RCALL SUBOPT_0x1F
	RCALL __DIVF21
	RCALL __CFD1
	MOV  R16,R30
	RCALL SUBOPT_0x22
	RCALL SUBOPT_0x23
	RCALL SUBOPT_0x13
	RCALL SUBOPT_0x24
	RCALL __MULF12
	RCALL SUBOPT_0x1F
	RCALL __SWAPD12
	RCALL __SUBF12
	RCALL SUBOPT_0x21
	RJMP _0x63
_0x65:
_0x62:
	LDD  R30,Y+8
	CPI  R30,0
	BRNE _0x66
	RCALL SUBOPT_0x25
	RJMP _0x6D
_0x66:
	RCALL SUBOPT_0x22
	LDI  R30,LOW(46)
	ST   X,R30
_0x67:
	LDD  R30,Y+8
	SUBI R30,LOW(1)
	STD  Y+8,R30
	SUBI R30,-LOW(1)
	BREQ _0x69
	RCALL SUBOPT_0x1F
	RCALL SUBOPT_0x9
	RCALL __MULF12
	RCALL SUBOPT_0x21
	RCALL SUBOPT_0x20
	RCALL __CFD1U
	MOV  R16,R30
	RCALL SUBOPT_0x22
	RCALL SUBOPT_0x23
	RCALL SUBOPT_0x1F
	RCALL SUBOPT_0x24
	RCALL SUBOPT_0x26
	RCALL SUBOPT_0x21
	RJMP _0x67
_0x69:
	RCALL SUBOPT_0x25
_0x6D:
	RCALL __LOADLOCR2
	ADIW R28,13
	RET
_sin:
	SBIW R28,4
	ST   -Y,R17
	LDI  R17,0
	RCALL SUBOPT_0x27
	__GETD1N 0x3E22F983
	RCALL __MULF12
	RCALL SUBOPT_0x28
	RCALL SUBOPT_0x29
	RCALL __PUTPARD1
	RCALL _floor
	RCALL SUBOPT_0x27
	RCALL SUBOPT_0x26
	RCALL SUBOPT_0x28
	RCALL SUBOPT_0x2A
	RCALL __CMPF12
	BREQ PC+2
	BRCC PC+2
	RJMP _0x6A
	RCALL SUBOPT_0x2A
	RCALL SUBOPT_0x26
	RCALL SUBOPT_0x28
	LDI  R17,LOW(1)
_0x6A:
	RCALL SUBOPT_0x27
	__GETD1N 0x3E800000
	RCALL __CMPF12
	BREQ PC+2
	BRCC PC+2
	RJMP _0x6B
	RCALL SUBOPT_0x2A
	RCALL __SUBF12
	RCALL SUBOPT_0x28
_0x6B:
	CPI  R17,0
	BREQ _0x6C
	RCALL SUBOPT_0x29
	RCALL __ANEGF1
	RCALL SUBOPT_0x28
_0x6C:
	RCALL SUBOPT_0x29
	RCALL SUBOPT_0x27
	RCALL __MULF12
	__PUTD1S 1
	RCALL SUBOPT_0x2B
	__GETD2N 0x4226C4B1
	RCALL __MULF12
	MOVW R26,R30
	MOVW R24,R22
	__GETD1N 0x422DE51D
	RCALL SUBOPT_0x26
	RCALL SUBOPT_0x2C
	__GETD2N 0x4104534C
	RCALL __ADDF12
	RCALL SUBOPT_0x27
	RCALL __MULF12
	PUSH R23
	PUSH R22
	PUSH R31
	PUSH R30
	RCALL SUBOPT_0x2B
	__GETD2N 0x3FDEED11
	RCALL __ADDF12
	RCALL SUBOPT_0x2C
	__GETD2N 0x3FA87B5E
	RCALL __ADDF12
	POP  R26
	POP  R27
	POP  R24
	POP  R25
	RCALL __DIVF21
	LDD  R17,Y+0
	ADIW R28,9
	RET
_cos:
	RCALL SUBOPT_0x1A
	__GETD1N 0x3FC90FDB
	RCALL __SUBF12
	RCALL __PUTPARD1
	RCALL _sin
	ADIW R28,4
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x0:
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	STS  132,R30
	STS  132+1,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x1:
	LDS  R26,_volt_accum
	LDS  R27,_volt_accum+1
	LDS  R24,_volt_accum+2
	LDS  R25,_volt_accum+3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x2:
	CLR  R31
	CLR  R22
	CLR  R23
	RCALL __DIVD21U
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x3:
	LDS  R26,_amp_accum
	LDS  R27,_amp_accum+1
	LDS  R24,_amp_accum+2
	LDS  R25,_amp_accum+3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x4:
	LDS  R26,_average_volt_accum
	LDS  R27,_average_volt_accum+1
	LDS  R24,_average_volt_accum+2
	LDS  R25,_average_volt_accum+3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x5:
	LDS  R26,_average_amp_accum
	LDS  R27,_average_amp_accum+1
	LDS  R24,_average_amp_accum+2
	LDS  R25,_average_amp_accum+3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x6:
	CLR  R22
	CLR  R23
	RCALL __ADDD12
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x7:
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x8:
	__GETD2S 6
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x9:
	__GETD1N 0x41200000
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 10 TIMES, CODE SIZE REDUCTION:16 WORDS
SUBOPT_0xA:
	LDI  R30,LOW(32)
	ST   -Y,R30
	RJMP _lcd_putchar

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:8 WORDS
SUBOPT_0xB:
	CLR  R22
	CLR  R23
	RCALL __CDF1
	__PUTD1S 0
	__GETD2S 0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0xC:
	RCALL __MULF12
	__PUTD1S 0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:13 WORDS
SUBOPT_0xD:
	STS  _power,R30
	STS  _power+1,R31
	STS  _power+2,R22
	STS  _power+3,R23
	__GETD1S 0
	RCALL __PUTPARD1
	LDI  R30,LOW(1)
	ST   -Y,R30
	RJMP _float_out

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0xE:
	LDS  R30,_average_amp
	LDS  R31,_average_amp+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0xF:
	LDS  R30,_max_amp_tact
	LDS  R31,_max_amp_tact+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x10:
	STS  _max_volt_tact,R30
	STS  _max_volt_tact+1,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x11:
	LDS  R26,_max_volt_tact
	LDS  R27,_max_volt_tact+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:13 WORDS
SUBOPT_0x12:
	__PUTD1S 2
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x13:
	__GETD2S 2
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0x14:
	RCALL SUBOPT_0x12
	__GETD1S 2
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x15:
	__GETD1S 2
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:12 WORDS
SUBOPT_0x16:
	LDS  R30,_power
	LDS  R31,_power+1
	LDS  R22,_power+2
	LDS  R23,_power+3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x17:
	RCALL __PUTPARD1
	LDI  R30,LOW(1)
	ST   -Y,R30
	RJMP _float_out

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x18:
	RCALL __PUTPARD1
	LDI  R30,LOW(2)
	ST   -Y,R30
	RJMP _float_out

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x19:
	__PUTD1S 0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x1A:
	__GETD2S 0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:10 WORDS
SUBOPT_0x1B:
	ST   -Y,R0
	ST   -Y,R1
	ST   -Y,R15
	ST   -Y,R22
	ST   -Y,R23
	ST   -Y,R24
	ST   -Y,R25
	ST   -Y,R26
	ST   -Y,R27
	ST   -Y,R30
	ST   -Y,R31
	IN   R30,SREG
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x1C:
	LDS  R30,_tact
	LDS  R31,_tact+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 8 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x1D:
	ST   -Y,R30
	RJMP __lcd_write_data

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x1E:
	RCALL __long_delay_G2
	LDI  R30,LOW(48)
	ST   -Y,R30
	RJMP __lcd_init_write_G2

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES, CODE SIZE REDUCTION:16 WORDS
SUBOPT_0x1F:
	__GETD2S 9
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x20:
	__GETD1S 9
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:10 WORDS
SUBOPT_0x21:
	__PUTD1S 9
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:18 WORDS
SUBOPT_0x22:
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	ADIW R26,1
	STD  Y+6,R26
	STD  Y+6+1,R27
	SBIW R26,1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x23:
	MOV  R30,R16
	SUBI R30,-LOW(48)
	ST   X,R30
	MOV  R30,R16
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x24:
	CLR  R31
	CLR  R22
	CLR  R23
	RCALL __CDF1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x25:
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	LDI  R30,LOW(0)
	ST   X,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x26:
	RCALL __SWAPD12
	RCALL __SUBF12
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 8 TIMES, CODE SIZE REDUCTION:19 WORDS
SUBOPT_0x27:
	__GETD2S 5
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:10 WORDS
SUBOPT_0x28:
	__PUTD1S 5
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x29:
	__GETD1S 5
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0x2A:
	RCALL SUBOPT_0x27
	__GETD1N 0x3F000000
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x2B:
	__GETD1S 1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x2C:
	__GETD2S 1
	RCALL __MULF12
	RET

_delay_ms:
	ld   r30,y+
	ld   r31,y+
	adiw r30,0
	breq __delay_ms1
__delay_ms0:
	__DELAY_USW 0xE66
	wdr
	sbiw r30,1
	brne __delay_ms0
__delay_ms1:
	ret

__ftrunc:
	ldd  r23,y+3
	ldd  r22,y+2
	ldd  r31,y+1
	ld   r30,y
	bst  r23,7
	lsl  r23
	sbrc r22,7
	sbr  r23,1
	mov  r25,r23
	subi r25,0x7e
	breq __ftrunc0
	brcs __ftrunc0
	cpi  r25,24
	brsh __ftrunc1
	clr  r26
	clr  r27
	clr  r24
__ftrunc2:
	sec
	ror  r24
	ror  r27
	ror  r26
	dec  r25
	brne __ftrunc2
	and  r30,r26
	and  r31,r27
	and  r22,r24
	rjmp __ftrunc1
__ftrunc0:
	clt
	clr  r23
	clr  r30
	clr  r31
	clr  r22
__ftrunc1:
	cbr  r22,0x80
	lsr  r23
	brcc __ftrunc3
	sbr  r22,0x80
__ftrunc3:
	bld  r23,7
	ld   r26,y+
	ld   r27,y+
	ld   r24,y+
	ld   r25,y+
	cp   r30,r26
	cpc  r31,r27
	cpc  r22,r24
	cpc  r23,r25
	bst  r25,7
	ret

_floor:
	rcall __ftrunc
	brne __floor1
__floor0:
	ret
__floor1:
	brtc __floor0
	ldi  r25,0xbf

__addfc:
	clr  r26
	clr  r27
	ldi  r24,0x80
	rjmp __addf12

__ADDD12:
	ADD  R30,R26
	ADC  R31,R27
	ADC  R22,R24
	ADC  R23,R25
	RET

__ANEGD1:
	COM  R31
	COM  R22
	COM  R23
	NEG  R30
	SBCI R31,-1
	SBCI R22,-1
	SBCI R23,-1
	RET

__LSRD12:
	TST  R30
	MOV  R0,R30
	MOVW R30,R26
	MOVW R22,R24
	BREQ __LSRD12R
__LSRD12L:
	LSR  R23
	ROR  R22
	ROR  R31
	ROR  R30
	DEC  R0
	BRNE __LSRD12L
__LSRD12R:
	RET

__LSLW2:
	LSL  R30
	ROL  R31
	LSL  R30
	ROL  R31
	RET

__LSRW4:
	LSR  R31
	ROR  R30
__LSRW3:
	LSR  R31
	ROR  R30
__LSRW2:
	LSR  R31
	ROR  R30
	LSR  R31
	ROR  R30
	RET

__CBD1:
	MOV  R31,R30
	ADD  R31,R31
	SBC  R31,R31
	MOV  R22,R31
	MOV  R23,R31
	RET

__CWD1:
	MOV  R22,R31
	ADD  R22,R22
	SBC  R22,R22
	MOV  R23,R22
	RET

__DIVD21U:
	PUSH R19
	PUSH R20
	PUSH R21
	CLR  R0
	CLR  R1
	CLR  R20
	CLR  R21
	LDI  R19,32
__DIVD21U1:
	LSL  R26
	ROL  R27
	ROL  R24
	ROL  R25
	ROL  R0
	ROL  R1
	ROL  R20
	ROL  R21
	SUB  R0,R30
	SBC  R1,R31
	SBC  R20,R22
	SBC  R21,R23
	BRCC __DIVD21U2
	ADD  R0,R30
	ADC  R1,R31
	ADC  R20,R22
	ADC  R21,R23
	RJMP __DIVD21U3
__DIVD21U2:
	SBR  R26,1
__DIVD21U3:
	DEC  R19
	BRNE __DIVD21U1
	MOVW R30,R26
	MOVW R22,R24
	MOVW R26,R0
	MOVW R24,R20
	POP  R21
	POP  R20
	POP  R19
	RET

__GETD1PF:
	LPM  R0,Z+
	LPM  R1,Z+
	LPM  R22,Z+
	LPM  R23,Z
	MOVW R30,R0
	RET

__PUTPARD1:
	ST   -Y,R23
	ST   -Y,R22
	ST   -Y,R31
	ST   -Y,R30
	RET

__SWAPD12:
	MOV  R1,R24
	MOV  R24,R22
	MOV  R22,R1
	MOV  R1,R25
	MOV  R25,R23
	MOV  R23,R1

__SWAPW12:
	MOV  R1,R27
	MOV  R27,R31
	MOV  R31,R1

__SWAPB12:
	MOV  R1,R26
	MOV  R26,R30
	MOV  R30,R1
	RET

__ANEGF1:
	SBIW R30,0
	SBCI R22,0
	SBCI R23,0
	BREQ __ANEGF10
	SUBI R23,0x80
__ANEGF10:
	RET

__ROUND_REPACK:
	TST  R21
	BRPL __REPACK
	CPI  R21,0x80
	BRNE __ROUND_REPACK0
	SBRS R30,0
	RJMP __REPACK
__ROUND_REPACK0:
	ADIW R30,1
	ADC  R22,R25
	ADC  R23,R25
	BRVS __REPACK1

__REPACK:
	LDI  R21,0x80
	EOR  R21,R23
	BRNE __REPACK0
	PUSH R21
	RJMP __ZERORES
__REPACK0:
	CPI  R21,0xFF
	BREQ __REPACK1
	LSL  R22
	LSL  R0
	ROR  R21
	ROR  R22
	MOV  R23,R21
	RET
__REPACK1:
	PUSH R21
	TST  R0
	BRMI __REPACK2
	RJMP __MAXRES
__REPACK2:
	RJMP __MINRES

__UNPACK:
	LDI  R21,0x80
	MOV  R1,R25
	AND  R1,R21
	LSL  R24
	ROL  R25
	EOR  R25,R21
	LSL  R21
	ROR  R24

__UNPACK1:
	LDI  R21,0x80
	MOV  R0,R23
	AND  R0,R21
	LSL  R22
	ROL  R23
	EOR  R23,R21
	LSL  R21
	ROR  R22
	RET

__CFD1U:
	SET
	RJMP __CFD1U0
__CFD1:
	CLT
__CFD1U0:
	PUSH R21
	RCALL __UNPACK1
	CPI  R23,0x80
	BRLO __CFD10
	CPI  R23,0xFF
	BRCC __CFD10
	RJMP __ZERORES
__CFD10:
	LDI  R21,22
	SUB  R21,R23
	BRPL __CFD11
	NEG  R21
	CPI  R21,8
	BRTC __CFD19
	CPI  R21,9
__CFD19:
	BRLO __CFD17
	SER  R30
	SER  R31
	SER  R22
	LDI  R23,0x7F
	BLD  R23,7
	RJMP __CFD15
__CFD17:
	CLR  R23
	TST  R21
	BREQ __CFD15
__CFD18:
	LSL  R30
	ROL  R31
	ROL  R22
	ROL  R23
	DEC  R21
	BRNE __CFD18
	RJMP __CFD15
__CFD11:
	CLR  R23
__CFD12:
	CPI  R21,8
	BRLO __CFD13
	MOV  R30,R31
	MOV  R31,R22
	MOV  R22,R23
	SUBI R21,8
	RJMP __CFD12
__CFD13:
	TST  R21
	BREQ __CFD15
__CFD14:
	LSR  R23
	ROR  R22
	ROR  R31
	ROR  R30
	DEC  R21
	BRNE __CFD14
__CFD15:
	TST  R0
	BRPL __CFD16
	RCALL __ANEGD1
__CFD16:
	POP  R21
	RET

__CDF1U:
	SET
	RJMP __CDF1U0
__CDF1:
	CLT
__CDF1U0:
	SBIW R30,0
	SBCI R22,0
	SBCI R23,0
	BREQ __CDF10
	CLR  R0
	BRTS __CDF11
	TST  R23
	BRPL __CDF11
	COM  R0
	RCALL __ANEGD1
__CDF11:
	MOV  R1,R23
	LDI  R23,30
	TST  R1
__CDF12:
	BRMI __CDF13
	DEC  R23
	LSL  R30
	ROL  R31
	ROL  R22
	ROL  R1
	RJMP __CDF12
__CDF13:
	MOV  R30,R31
	MOV  R31,R22
	MOV  R22,R1
	PUSH R21
	RCALL __REPACK
	POP  R21
__CDF10:
	RET

__SWAPACC:
	PUSH R20
	MOVW R20,R30
	MOVW R30,R26
	MOVW R26,R20
	MOVW R20,R22
	MOVW R22,R24
	MOVW R24,R20
	MOV  R20,R0
	MOV  R0,R1
	MOV  R1,R20
	POP  R20
	RET

__UADD12:
	ADD  R30,R26
	ADC  R31,R27
	ADC  R22,R24
	RET

__NEGMAN1:
	COM  R30
	COM  R31
	COM  R22
	SUBI R30,-1
	SBCI R31,-1
	SBCI R22,-1
	RET

__SUBF12:
	PUSH R21
	RCALL __UNPACK
	CPI  R25,0x80
	BREQ __ADDF129
	LDI  R21,0x80
	EOR  R1,R21

	RJMP __ADDF120

__ADDF12:
	PUSH R21
	RCALL __UNPACK
	CPI  R25,0x80
	BREQ __ADDF129

__ADDF120:
	CPI  R23,0x80
	BREQ __ADDF128
__ADDF121:
	MOV  R21,R23
	SUB  R21,R25
	BRVS __ADDF129
	BRPL __ADDF122
	RCALL __SWAPACC
	RJMP __ADDF121
__ADDF122:
	CPI  R21,24
	BRLO __ADDF123
	CLR  R26
	CLR  R27
	CLR  R24
__ADDF123:
	CPI  R21,8
	BRLO __ADDF124
	MOV  R26,R27
	MOV  R27,R24
	CLR  R24
	SUBI R21,8
	RJMP __ADDF123
__ADDF124:
	TST  R21
	BREQ __ADDF126
__ADDF125:
	LSR  R24
	ROR  R27
	ROR  R26
	DEC  R21
	BRNE __ADDF125
__ADDF126:
	MOV  R21,R0
	EOR  R21,R1
	BRMI __ADDF127
	RCALL __UADD12
	BRCC __ADDF129
	ROR  R22
	ROR  R31
	ROR  R30
	INC  R23
	BRVC __ADDF129
	RJMP __MAXRES
__ADDF128:
	RCALL __SWAPACC
__ADDF129:
	RCALL __REPACK
	POP  R21
	RET
__ADDF127:
	SUB  R30,R26
	SBC  R31,R27
	SBC  R22,R24
	BREQ __ZERORES
	BRCC __ADDF1210
	COM  R0
	RCALL __NEGMAN1
__ADDF1210:
	TST  R22
	BRMI __ADDF129
	LSL  R30
	ROL  R31
	ROL  R22
	DEC  R23
	BRVC __ADDF1210

__ZERORES:
	CLR  R30
	CLR  R31
	CLR  R22
	CLR  R23
	POP  R21
	RET

__MINRES:
	SER  R30
	SER  R31
	LDI  R22,0x7F
	SER  R23
	POP  R21
	RET

__MAXRES:
	SER  R30
	SER  R31
	LDI  R22,0x7F
	LDI  R23,0x7F
	POP  R21
	RET

__MULF12:
	PUSH R21
	RCALL __UNPACK
	CPI  R23,0x80
	BREQ __ZERORES
	CPI  R25,0x80
	BREQ __ZERORES
	EOR  R0,R1
	SEC
	ADC  R23,R25
	BRVC __MULF124
	BRLT __ZERORES
__MULF125:
	TST  R0
	BRMI __MINRES
	RJMP __MAXRES
__MULF124:
	PUSH R0
	PUSH R17
	PUSH R18
	PUSH R19
	PUSH R20
	CLR  R17
	CLR  R18
	CLR  R25
	MUL  R22,R24
	MOVW R20,R0
	MUL  R24,R31
	MOV  R19,R0
	ADD  R20,R1
	ADC  R21,R25
	MUL  R22,R27
	ADD  R19,R0
	ADC  R20,R1
	ADC  R21,R25
	MUL  R24,R30
	RCALL __MULF126
	MUL  R27,R31
	RCALL __MULF126
	MUL  R22,R26
	RCALL __MULF126
	MUL  R27,R30
	RCALL __MULF127
	MUL  R26,R31
	RCALL __MULF127
	MUL  R26,R30
	ADD  R17,R1
	ADC  R18,R25
	ADC  R19,R25
	ADC  R20,R25
	ADC  R21,R25
	MOV  R30,R19
	MOV  R31,R20
	MOV  R22,R21
	MOV  R21,R18
	POP  R20
	POP  R19
	POP  R18
	POP  R17
	POP  R0
	TST  R22
	BRMI __MULF122
	LSL  R21
	ROL  R30
	ROL  R31
	ROL  R22
	RJMP __MULF123
__MULF122:
	INC  R23
	BRVS __MULF125
__MULF123:
	RCALL __ROUND_REPACK
	POP  R21
	RET

__MULF127:
	ADD  R17,R0
	ADC  R18,R1
	ADC  R19,R25
	RJMP __MULF128
__MULF126:
	ADD  R18,R0
	ADC  R19,R1
__MULF128:
	ADC  R20,R25
	ADC  R21,R25
	RET

__DIVF21:
	PUSH R21
	RCALL __UNPACK
	CPI  R23,0x80
	BRNE __DIVF210
	TST  R1
__DIVF211:
	BRPL __DIVF219
	RJMP __MINRES
__DIVF219:
	RJMP __MAXRES
__DIVF210:
	CPI  R25,0x80
	BRNE __DIVF218
__DIVF217:
	RJMP __ZERORES
__DIVF218:
	EOR  R0,R1
	SEC
	SBC  R25,R23
	BRVC __DIVF216
	BRLT __DIVF217
	TST  R0
	RJMP __DIVF211
__DIVF216:
	MOV  R23,R25
	PUSH R17
	PUSH R18
	PUSH R19
	PUSH R20
	CLR  R1
	CLR  R17
	CLR  R18
	CLR  R19
	CLR  R20
	CLR  R21
	LDI  R25,32
__DIVF212:
	CP   R26,R30
	CPC  R27,R31
	CPC  R24,R22
	CPC  R20,R17
	BRLO __DIVF213
	SUB  R26,R30
	SBC  R27,R31
	SBC  R24,R22
	SBC  R20,R17
	SEC
	RJMP __DIVF214
__DIVF213:
	CLC
__DIVF214:
	ROL  R21
	ROL  R18
	ROL  R19
	ROL  R1
	ROL  R26
	ROL  R27
	ROL  R24
	ROL  R20
	DEC  R25
	BRNE __DIVF212
	MOVW R30,R18
	MOV  R22,R1
	POP  R20
	POP  R19
	POP  R18
	POP  R17
	TST  R22
	BRMI __DIVF215
	LSL  R21
	ROL  R30
	ROL  R31
	ROL  R22
	DEC  R23
	BRVS __DIVF217
__DIVF215:
	RCALL __ROUND_REPACK
	POP  R21
	RET

__CMPF12:
	TST  R25
	BRMI __CMPF120
	TST  R23
	BRMI __CMPF121
	CP   R25,R23
	BRLO __CMPF122
	BRNE __CMPF121
	CP   R26,R30
	CPC  R27,R31
	CPC  R24,R22
	BRLO __CMPF122
	BREQ __CMPF123
__CMPF121:
	CLZ
	CLC
	RET
__CMPF122:
	CLZ
	SEC
	RET
__CMPF123:
	SEZ
	CLC
	RET
__CMPF120:
	TST  R23
	BRPL __CMPF122
	CP   R25,R23
	BRLO __CMPF121
	BRNE __CMPF122
	CP   R30,R26
	CPC  R31,R27
	CPC  R22,R24
	BRLO __CMPF122
	BREQ __CMPF123
	RJMP __CMPF121

__CPD20:
	SBIW R26,0
	SBCI R24,0
	SBCI R25,0
	RET

__SAVELOCR2:
	ST   -Y,R17
	ST   -Y,R16
	RET

__LOADLOCR2:
	LDD  R17,Y+1
	LD   R16,Y
	RET

__LOADLOCR2P:
	LD   R16,Y+
	LD   R17,Y+
	RET

;END OF CODE MARKER
__END_OF_CODE:
