// CodeVisionAVR C Compiler
// (C) 1998-2004 Pavel Haiduc, HP InfoTech S.R.L.

// I/O registers definitions for the ATmega88(V)


#pragma used+
#pragma used+
#pragma used+
sfrb PINB=3;
sfrb DDRB=4;
sfrb PORTB=5;
sfrb PINC=6;
sfrb DDRC=7;
sfrb PORTC=8;
sfrb PIND=9;
sfrb DDRD=0xa;
sfrb PORTD=0xb;
sfrb TIFR0=0x15;
sfrb TIFR1=0x16;
sfrb TIFR2=0x17;
sfrb PCIFR=0x1b;
sfrb EIFR=0x1c;
sfrb EIMSK=0x1d;
sfrb GPIOR0=0x1e;
sfrb EECR=0x1f;
sfrb EEDR=0x20;
sfrb EEARL=0x21;
sfrb EEARH=0x22;
sfrw EEAR=0x21;   // 16 bit access
sfrb GTCCR=0x23;
sfrb TCCR0A=0x24;
sfrb TCCR0B=0x25;
sfrb TCNT0=0x26;
sfrb OCR0A=0x27;
sfrb OCR0B=0x28;
sfrb GPIOR1=0x2a;
sfrb GPIOR2=0x2b;
sfrb SPCR=0x2c;
sfrb SPSR=0x2d;
sfrb SPDR=0x2e;
sfrb ACSR=0x30;
sfrb MONDR=0x31;
sfrb SMCR=0x33;
sfrb MCUSR=0x34;
sfrb MCUCR=0x35;
sfrb SPMCSR=0x37;
sfrb SPL=0x3d;
sfrb SPH=0x3e;
sfrb SREG=0x3f;
#pragma used-




// Interrupt vectors definitions


// Needed by the power management functions (sleep.h)
#asm
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x01
	.EQU __sm_mask=0x0E
	.EQU __sm_adc_noise_red=0x02
	.EQU __sm_powerdown=0x04
	.EQU __sm_powersave=0x06
	.EQU __sm_standby=0x0C
	.SET power_ctrl_reg=smcr
	#endif
#endasm




// Alphanumeric LCD Module functions
#asm
   .equ __lcd_port=0x0B ;PORTD
#endasm
/* LCD driver routines

  CodeVisionAVR C Compiler
  (C) 1998-2003 Pavel Haiduc, HP InfoTech S.R.L.

  BEFORE #include -ING THIS FILE YOU
  MUST DECLARE THE I/O ADDRESS OF THE
  DATA REGISTER OF THE PORT AT WHICH
  THE LCD IS CONNECTED!

  EXAMPLE FOR PORTB:

    #asm
        .equ __lcd_port=0x18
    #endasm
    #include <lcd.h>

*/


#pragma used+
#pragma used+

void _lcd_ready(void);
void _lcd_write_data(unsigned char data);
// write a byte to the LCD character generator or display RAM
void lcd_write_byte(unsigned char addr, unsigned char data);
// read a byte from the LCD character generator or display RAM
unsigned char lcd_read_byte(unsigned char addr);
// set the LCD display position  x=0..39 y=0..3
void lcd_gotoxy(unsigned char x, unsigned char y);
// clear the LCD
void lcd_clear(void);
void lcd_putchar(char c);
// write the string str located in SRAM to the LCD
void lcd_puts(char *str);
// write the string str located in FLASH to the LCD
void lcd_putsf(char flash *str);
// initialize the LCD controller
unsigned char lcd_init(unsigned char lcd_columns);

#pragma used-
#pragma library lcd.lib


/* CodeVisionAVR C Compiler
   Prototypes for standard library functions

   (C) 1998-2003 Pavel Haiduc, HP InfoTech S.R.L.
*/




#pragma used+
#pragma used+

int atoi(char *str);
long int atol(char *str);
float atof(char *str);
void itoa(int n,char *str);
void ltoa(long int n,char *str);
void ftoa(float n,unsigned char decimals,char *str);
void ftoe(float n,unsigned char decimals,char *str);
void srand(int seed);
int rand(void);
void *malloc(unsigned int size);
void *calloc(unsigned int num, unsigned int size);
void *realloc(void *ptr, unsigned int size); 
void free(void *ptr);

#pragma used-
#pragma library stdlib.lib


// CodeVisionAVR C Compiler
// (C) 1998-2000 Pavel Haiduc, HP InfoTech S.R.L.


#pragma used+
#pragma used+

void delay_us(unsigned int n);
void delay_ms(unsigned int n);

#pragma used-


//  --- 0xA0
//  --- 0xA1
//  --- 0xA2
//  --- 0xA3
//  --- 0xA4
//  --- 0xA5
//  --- 0xA6
//  --- 0xA7
//  --- 0xA8
//  --- 0xA9
//  --- 0xAA
//  --- 0xAB
//  --- 0xA
//  --- 0xAD
//  --- 0xAE
//  --- 0xAF
//  --- 0xB0
//  --- 0xB1
//  --- 0xB2
//  --- 0xB3
//  --- 0xB4
//  --- 0xB5
//  --- 0xB6
//  --- 0xB7
//  --- 0xB8
//  --- 0xB9
//  --- 0xBA
//  --- 0xBB
//  --- 0xBC
//  --- 0xBD
//  --- 0xBE
//  --- 0xBF
//  --- 0xC0
//  --- 0xC1
//  --- 0xC2
//  --- 0xC3
//  --- 0xC4
//  --- 0xC5
//  --- 0xC6
//  --- 0xC7
//  --- 0xE0
//  --- 0xE1
//  --- 0xE2
//  --- 0xE3
//  --- 0xE4
//  --- 0xE5
//  --- 0xE6
/*
CodeVisionAVR C Compiler
Prototypes for mathematical functions

Portions (C) 1998-2001 Pavel Haiduc, HP InfoTech S.R.L.
Portions (C) 2000-2001 Yuri G. Salov
*/



#pragma used+
#pragma used+
#pragma used+

unsigned char cabs(signed char x);
unsigned int abs(int x);
unsigned long labs(long x);
float fabs(float x);
signed char cmax(signed char a,signed char b);
int max(int a,int b);
long lmax(long a,long b);
float fmax(float a,float b);
signed char cmin(signed char a,signed char b);
int min(int a,int b);
long lmin(long a,long b);
float fmin(float a,float b);
signed char csign(signed char x);
signed char sign(int x);
signed char lsign(long x);
signed char fsign(float x);
unsigned char isqrt(unsigned int x);
unsigned int lsqrt(unsigned long x);
float sqrt(float x);
float floor(float x);
float ceil(float x);
float fmod(float x,float y);
float modf(float x,float *ipart);
float ldexp(float x,int expon);
float frexp(float x,int *expon);
float exp(float x);
float log(float x);
float log10(float x);
float pow(float x,float y);
float sin(float x);
float cos(float x);
float tan(float x);
float sinh(float x);
float cosh(float x);
float tanh(float x);
float asin(float x);
float acos(float x);
float atan(float x);
float atan2(float y,float x);

#pragma used-
#pragma library math.lib







bit display_changed=1;
bit display_changed=1;

char second_counter=0; //
char seconds=0;
char minutes=0;
char hours=0;  
char days=0;

bit measure_start=0;  
bit timer_started=0;

unsigned int period; //      

unsigned long int volt_accum; //    	
unsigned long int amp_accum; //      

unsigned long int average_volt_accum; //    	
unsigned long int average_amp_accum; //     

char volt_measures;
char amp_measures;

char average_counter; //    

unsigned int volt;
unsigned int amp; 

unsigned int average_volt;
unsigned int average_amp;
unsigned int average_period_accum;  
unsigned int average_period;

char measure_time_counter=0; //    

float power; 
float active;
float reactive;
float cosinus;
float sinus;

char buttons_counter=0;
bit  buttons_timer=0; //      
bit  new_menu=0;//    

char menu_num=0;

unsigned int max_amp;
unsigned int max_volt;
unsigned int tact;
unsigned int max_amp_tact;
unsigned int max_volt_tact; 

//1.1V
// ADMUX=0b11000001; 
// ADMUX=0b11000000;  

//2.45V
// ADMUX=0b00000001; 
// ADMUX=0b00000000; 

// ADCSRA=0b11001111; //   
// TCCR1B=0x05; //         
// TCCR1B=0x00; //  

void freq_start(void)
void freq_start(void)
{     
     (*(unsigned int *) 0x84)=0;
     (*(unsigned char *) 0x81)=0x05; //   
     max_amp=0;
     max_volt=0;
     tact=0;   
} 

void freq_stop(void)
{
     (*(unsigned char *) 0x81)=0x00; //  
     period=(*(unsigned int *) 0x84);
     (*(unsigned int *) 0x84)=0;
}

void volt_amp_calc(void) // 
{
     volt=volt_accum/volt_measures; 
     amp=amp_accum/amp_measures; 
     
     volt_accum=0;
     amp_accum=0; 
     volt_measures=0;
     amp_measures=0;
     
     if(average_counter==16)// ,    16   8, . 1  
     {
          average_counter=0;
          average_volt=average_volt_accum>>3;
          average_amp=average_amp_accum>>3;
          average_period=average_period_accum>>4;
          average_volt_accum=0;
          average_amp_accum=0;
          average_period_accum=0;
          display_changed=1;
     }
     else
     { 
          average_counter++;
          average_volt_accum=average_volt_accum+volt;
          average_amp_accum=average_amp_accum+amp;
          average_period_accum=average_period_accum+period;
     }
     
     
}


void check_metering(void)
{
     if(timer_started==0 ) //  
     {
          timer_started=1;
          freq_start();
     }
     else //  
     {
          timer_started=0 ;
          freq_stop();
          volt_amp_calc();// 
          measure_start=0 ;
     }
}
 void float_out(float f,char digits)//   LCD 
void float_out(float f,char digits)void float_out(float f,char digits) {       
        char mas[5];
        ftoa(f,digits,mas);
        
        if(f<10)
        {
            lcd_putchar(' '); 
            lcd_putchar(' '); 
            lcd_putchar(' '); 
            lcd_puts(mas);
        }  
        else if(f<100) 
        {
            lcd_putchar(' '); 
            lcd_putchar(' '); 
            lcd_puts(mas);
        }  
        else if(f<1000) 
        {
            lcd_putchar(' '); 
            lcd_puts(mas);
        } 
        
       if(digits==0)
       {
          lcd_putchar(' '); 
          lcd_putchar(' '); 
          lcd_putchar(' '); 
          lcd_putchar(' '); 
       }  
       
       if(digits==1)
       {
          lcd_putchar(' '); 
          lcd_putchar(' ');  
       } 
       
       if(digits==2)
       {
          lcd_putchar(' ');  
       }
 }
 
 
 void volt_amp(void)
 {   
    float f;
    
    f=average_volt;
    f=f*0.3716;
    power=f;
    float_out(f,1);
    
    f=average_amp;
    f=f*0.01625;
    power=power*f; 
    float_out(f,1); 
    
 } 
 
  void pow_fact(void)
 { 
    char mas[5];
    int i; 
    float f;
    
    if(average_amp==0)max_volt_tact=max_amp_tact;
    
    if(max_volt_tact>max_amp_tact)i=max_volt_tact-max_amp_tact; 
    else i=max_amp_tact-max_volt_tact; 
      
    f=i;
    
    f=f/145;
    f=2*3.14*f;
    cosinus=cos(f); 
    sinus=sin(f); 
    
    float_out(power,1);

    float_out(cosinus,2);
 }
 
  void active_passive(void)
 { 
     active=cosinus*power;  
     reactive=sinus*power;
     
     float_out(active,1); 
     float_out(reactive,1);
 }
 
   void freq(void)
 {      
    float f;
 
    f=14400;
    f=f/average_period;
    float_out(f,2);
 }


void lcd_refresh(void)
{     
    char mas[5];
    float f;
    display_changed=0 ;
    lcd_clear();
  
   
    /*
    i=hours;
    itoa(i,mas);
    lcd_puts(mas);
     
    lcd_putchar(':'); 
     
    i=minutes;
    itoa(i,mas);
    lcd_puts(mas); 
    
    lcd_putchar(':');
     
    i=seconds;
    itoa(i,mas);
    lcd_puts(mas);
    */
    
    /*
    f=14400;
    f=f/period;
    ftoa(f,2,mas);
    lcd_puts(mas);
    */ 
     
     /////////////////////////////
    /*
    f=average_volt;
    f=f*0.3716;
    power=f;
    
    ftoa(f,1,mas);
    lcd_puts(mas); 
    
    lcd_putchar(' ');
     
    f=average_amp;
    f=f*0.01625;
    ftoa(f,2,mas);
    lcd_puts(mas);
    
    lcd_putchar(' '); 
    power=power*f; 
    ftoa(power,2,mas);
    lcd_puts(mas);
     */
    //////////////////////////////
    
    /*lcd_putchar(' ');  
    f=14400;
    f=f/average_period;
    ftoa(f,2,mas);
    lcd_puts(mas);*/ 
    
    if(new_menu==1)//
    {
        new_menu=0 ;
        lcd_clear();
        switch(menu_num)
        {     
              case 0 :{lcd_putsf("Voltage ");lcd_putsf("Current ");}break;  //   
              case 1 :{lcd_putsf("Power   ");lcd_putsf("Facror  ");}break;  //    
              case 2 :{lcd_putsf("Active  ");lcd_putsf("Reactive");}break;  //    
              case 3 :{lcd_putsf("Freqency");}break;  // 
        } 
        delay_ms(1500);
        lcd_clear();
    }
    
    switch(menu_num)
    {     
        case 0 :{volt_amp();}break;  //   
        case 1 :{pow_fact();}break;  //    
        case 2 :{active_passive();}break;  //      
        case 3 :{freq();}break;  // 
    }           
}




void init(void)
{
// Declare your local variables here

// Crystal Oscillator division factor: 1
#pragma optsize-
(*(unsigned char *) 0x61)=0x80;
(*(unsigned char *) 0x61)=0x00;
#pragma optsize+

// Input/Output Ports initialization
// Port B initialization
// Func7=In Func6=In Func5=Out Func4=In Func3=In Func2=In Func1=In Func0=In 
// State7=T State6=T State5=0 State4=T State3=T State2=T State1=T State0=T 
PORTB=0x00;
DDRB=0x20;

// Port C initialization
// Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
// State6=T State5=T State4=P State3=P State2=P State1=T State0=T 
PORTC=0x1C;
DDRC=0x00;

// Port D initialization
// Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
// State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T 
PORTD=0x00;
DDRD=0x00;

// Timer/Counter 0 initialization
// Clock source: System Clock
// Clock value: 57,600 kHz
// Mode: Normal top=FFh
// OC0A output: Disconnected
// OC0B output: Disconnected
TCCR0A=0x00;
TCCR0B=0x04;
TCNT0=0x00;
OCR0A=0x00;
OCR0B=0x00;

// Timer/Counter 1 initialization
// Clock source: System Clock
// Clock value: Timer 1 Stopped
// Mode: Normal top=FFFFh
// OC1A output: Discon.
// OC1B output: Discon.
// Noise Canceler: Off
// Input Capture on Falling Edge
// Timer 1 Overflow Interrupt: Off
// Input Capture Interrupt: Off
// Compare A Match Interrupt: Off
// Compare B Match Interrupt: Off
(*(unsigned char *) 0x80)=0x00;
(*(unsigned char *) 0x81)=0x00;
(*(unsigned char *) 0x85)=0x00;
(*(unsigned char *) 0x84)=0x00;
(*(unsigned char *) 0x87)=0x00;
(*(unsigned char *) 0x86)=0x00;
(*(unsigned char *) 0x89)=0x00;
(*(unsigned char *) 0x88)=0x00;
(*(unsigned char *) 0x8b)=0x00;
(*(unsigned char *) 0x8a)=0x00;

// Timer/Counter 2 initialization
// Clock source: System Clock
// Clock value: 230,400 kHz
// Mode: Normal top=FFh
// OC2A output: Disconnected
// OC2B output: Disconnected
(*(unsigned char *) 0xb6)=0x00;
(*(unsigned char *) 0xb0)=0x00;
(*(unsigned char *) 0xb1)=0x02;
(*(unsigned char *) 0xb2)=0x00;
(*(unsigned char *) 0xb3)=0xF0;
(*(unsigned char *) 0xb4)=0x00;

// External Interrupt(s) initialization
// INT0: Off
// INT1: On
// INT1 Mode: Falling Edge
// Interrupt on any change on pins PCINT0-7: Off
// Interrupt on any change on pins PCINT8-14: Off
// Interrupt on any change on pins PCINT16-23: Off
(*(unsigned char *) 0x69)=0x08;
EIMSK=0x02;
EIFR=0x02;
(*(unsigned char *) 0x68)=0x00;

// Timer/Counter 0 Interrupt(s) initialization
(*(unsigned char *) 0x6e)=0x01;
// Timer/Counter 1 Interrupt(s) initialization
(*(unsigned char *) 0x6f)=0x00;
// Timer/Counter 2 Interrupt(s) initialization
(*(unsigned char *) 0x70)=0x02;

// Analog Comparator initialization
// Analog Comparator: Off
// Analog Comparator Input Capture by Timer/Counter 1: Off
ACSR=0x80;
(*(unsigned char *) 0x7b)=0x00;

// ADC initialization
// ADC Clock frequency: 115,200 kHz
// ADC Voltage Reference: Int., cap. on AREF
// ADC Auto Trigger Source: None
// Digital input buffers on ADC0: On, ADC1: On, ADC2: On, ADC3: On
// ADC4: On, ADC5: On
(*(unsigned char *) 0x7e)=0x00;
(*(unsigned char *) 0x7c)=0xC0 & 0xff;
(*(unsigned char *) 0x7a)=0x8F;

delay_ms(1000);

// LCD module initialization
lcd_init(8);



// Global enable interrupts
#asm("sei")
}

interrupt [3] void ext_int1_isr(void) //     
{    
    if(measure_start==1)
    {
        check_metering();
    }
}



void buttons_timer_routine(void)
{
      if(buttons_timer==1)//  ,  
      {
            if(buttons_counter==110) // 1 
            {
                buttons_counter=0;
                buttons_timer=0 ; 
            }
            else buttons_counter++; 
      } 
      else
      {
          if(PINC.3  ==0)
          {
                if(menu_num==3)menu_num=0;
                else menu_num++;
                buttons_timer=1;
                new_menu=1;
                display_changed=1;
          }

      }
      
        
}



interrupt [17] void timer0_ovf_isr(void) //   225   
{    
    buttons_timer_routine();

    if(measure_time_counter==25){if(measure_start==0 )measure_start=1; measure_time_counter=0;} //   9   .
    else measure_time_counter++;
    
    if(second_counter==225)
    {    
        second_counter=0;
        seconds++; 
    }
    else second_counter++; 
    
    if(seconds==60){minutes++;seconds=0;}else return;
    if(minutes==60){hours++;minutes=0;}else return;
    if(hours==24){days++;hours=0;}   
}


interrupt [8] void timer2_compa_isr(void) //
{
    if(timer_started==1)(*(unsigned char *) 0x7a)=0b11001110;//  
}



interrupt [22] void adc_isr(void)
{
    unsigned int adc_data;
    adc_data=(*(unsigned int *) 0x78) ;   

    if((*(unsigned char *) 0x7c)==0b00000001)//
    {
        (*(unsigned char *) 0x7c)=0b00000000; //  
        volt_measures++;
        volt_accum=volt_accum+adc_data; 
        
        if(adc_data>max_volt){max_volt=adc_data; max_volt_tact=tact;}
        
    }
    else// 
    {
        (*(unsigned char *) 0x7c)=0b00000001; //  
        amp_measures++;
        amp_accum=amp_accum+adc_data; 
        
        if(adc_data>max_amp){max_amp=adc_data; max_amp_tact=tact;}
        
    }  
    
    tact++;
    
}


void main(void)
{
    init();

    while (1)
    {
          if(display_changed==1)lcd_refresh();
    };
}
